<?php

/*
 * This file is part of the Symfony package.
 *
 * (c) Fabien Potencier <fabien@symfony.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
namespace Freefactu_Vendor\Symfony\Component\Validator\Constraints;

use Freefactu_Vendor\Symfony\Component\ExpressionLanguage\ExpressionLanguage;
use Freefactu_Vendor\Symfony\Component\ExpressionLanguage\Parser;
use Freefactu_Vendor\Symfony\Component\ExpressionLanguage\SyntaxError;
use Freefactu_Vendor\Symfony\Component\Validator\Constraint;
use Freefactu_Vendor\Symfony\Component\Validator\ConstraintValidator;
use Freefactu_Vendor\Symfony\Component\Validator\Exception\UnexpectedTypeException;
use Freefactu_Vendor\Symfony\Component\Validator\Exception\UnexpectedValueException;
/**
 * @author Andrey Sevastianov <mrpkmail@gmail.com>
 */
class ExpressionSyntaxValidator extends ConstraintValidator
{
    public function __construct(private ?ExpressionLanguage $expressionLanguage = null)
    {
    }
    public function validate(mixed $expression, Constraint $constraint): void
    {
        if (!$constraint instanceof ExpressionSyntax) {
            throw new UnexpectedTypeException($constraint, ExpressionSyntax::class);
        }
        if (null === $expression || '' === $expression) {
            return;
        }
        if (!\is_string($expression) && !$expression instanceof \Stringable) {
            throw new UnexpectedValueException($expression, 'string');
        }
        $this->expressionLanguage ??= new ExpressionLanguage();
        try {
            if (null === $constraint->allowedVariables && \defined(Parser::class . '::IGNORE_UNKNOWN_VARIABLES')) {
                $this->expressionLanguage->lint($expression, [], Parser::IGNORE_UNKNOWN_VARIABLES);
            } else {
                $this->expressionLanguage->lint($expression, $constraint->allowedVariables);
            }
        } catch (SyntaxError $exception) {
            $this->context->buildViolation($constraint->message)->setParameter('{{ syntax_error }}', $this->formatValue($exception->getMessage()))->setInvalidValue((string) $expression)->setCode(ExpressionSyntax::EXPRESSION_SYNTAX_ERROR)->addViolation();
        }
    }
}
